/* 
   COPYRIGHT 2004 KRUPCZAK.ORG, LLC.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA
 
   For more information, visit:
   http://www.krupczak.org/
*/

/* file - globals.h */
/* rdk@krupczak.org */

/* Definitions for global variables, facilities, to core agent engine etc. */

/* ************************************************************* */
/* define as extern those variables needed by other modules
   but which do not require unnecessary include files in order
   for them to be syntactically correct */

extern float xmpd_version;
extern int xmpd_daemon;
extern int xmpd_trace;
extern u_short xmpd_port;
extern char *xmpd_config_file;
extern int xmpd_config_version;
extern char xmpd_home_dir[];
extern int xmpd_verbose;
extern int xmpd_update_configfile; 
extern int win32service;
extern int globalShutdown;
extern char sysName[];
extern int xmp_session_verbose;
extern int xmpd_no_modules;
extern int dumpcore;
extern int eventAgeOutInterval;
extern char defaultManager[];
extern time_t xmpd_init_time;
extern int autoUpgrade;
extern int sslInit;
extern char *versionStr;

#define XMPD_LOGFILE   "xmpd.log"

int xmpd_log(char *);
int open_log();
int close_log();
int getApplicationName(char *,int);
int initCore();
int writeXmpdConfigFile();
int readXmpdConfigFile(char *);
int processEvents();
int upgradeCartographer();

/* ************************************************************* */
