/* 
   COPYRIGHT 2006 KRUPCZAK.ORG, LLC.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA
 
   For more information, visit:
   http://www.krupczak.org/
*/

/* file - xmp_events.h */
/* rdk@krupczak.org */

/* core MIB events table definitions */

/* ************************************************************* */

typedef struct xmpEventEntry {

  char eventSource[256];   /* system event originated from; \0 if local */
  time_t timeStamp;        /* time event received or created locally */

  int ageOut;              /* age-out interval in seconds */
  int dispatched;          /* has this event been dispatched yet? */

  char eventType[256];
  char sysObjectID[256];

  xmpPdu_t *eventPdu;      /* the event PDU itself */
  char *eventPduXml;       /* the XML-encoded PDU, non-zero terminated */
  int xmlSize;

} xmpEventEntry_t;

xmpErrorStatus_t sendTrap(char *, xmpPdu_t *, char *, char *, char *);
xmpErrorStatus_t receiveTrap(char *, xmpPdu_t *, u_char *, int);
xmpErrorStatus_t receiveInformation(char *, xmpPdu_t *, u_char *, int);
int sendColdstartTrap();
int initCoreEvents();

typedef struct xmpEventRegistry {

   char trapFilter[256];

#ifndef WIN32
   int  (*trapHandler)();   /* trap handler function */
#else
   FARPROC trapHandler;
#endif

   time_t registerTime;

} xmpEventRegistry_t;

/* ************************************************************* */


